//+------------------------------------------------------------------+
//|                                                         MASO.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Gray
#property indicator_color2 Green
#property indicator_color3 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern int Length1=50;
extern int Method1=0;  // 0 - SMA
                       // 1 - EMA
                       // 2 - SMMA
                       // 3 - LWMA
extern double Slope1=0;
extern int Slope_Length1=1;
extern int Price1=0;      // Applied price
                          // 0 - Close
                          // 1 - Open
                          // 2 - High
                          // 3 - Low
                          // 4 - Median
                          // 5 - Typical
                          // 6 - Weighted  

extern int Length2=10;
extern int Method2=1;  // 0 - SMA
                       // 1 - EMA
                       // 2 - SMMA
                       // 3 - LWMA
extern double Slope2=0;
extern int Slope_Length2=1;
extern int Price2=0;      // Applied price
                          // 0 - Close
                          // 1 - Open
                          // 2 - High
                          // 3 - Low
                          // 4 - Median
                          // 5 - Typical
                          // 6 - Weighted  


double MASO[], MASO_Up[], MASO_Dn[];

int init()
{
 IndicatorShortName("MA Slope Oscilator");
 IndicatorDigits(Digits);
 SetIndexStyle(0,DRAW_HISTOGRAM);
 SetIndexBuffer(0,MASO);
 SetIndexStyle(1,DRAW_HISTOGRAM);
 SetIndexBuffer(1,MASO_Up);
 SetIndexStyle(2,DRAW_HISTOGRAM);
 SetIndexBuffer(2,MASO_Dn);
 
 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 double MA_Slope1, MA_Slope1_Up, MA_Slope1_Dn, MA_Slope2, MA_Slope2_Up, MA_Slope2_Dn,Sl,MA1,MA2;
 pos=limit;
   while(pos>=0)
   {
      MA_Slope1_Up = 0;
      MA_Slope1_Dn = 0;
      MA_Slope2_Up = 0;
      MA_Slope2_Dn = 0;
      MASO[pos]    = 0;
      MASO_Up[pos] = 0;
      MASO_Dn[pos] = 0;
 
      MA1=iMA(NULL, 0, Length1, 0, Method1, Price1, pos); Sl=(MA1-iMA(NULL, 0, Length1, 0, Method1, Price1, pos+Slope_Length1))/Point;
      MA_Slope1 = MA1;
         if (Sl>Slope1) MA_Slope1_Up=MA1;
         if (Sl<Slope1) MA_Slope1_Dn=MA1;
      MA2=iMA(NULL, 0, Length2, 0, Method2, Price2, pos); Sl=(MA2-iMA(NULL, 0, Length2, 0, Method2, Price2, pos+Slope_Length2))/Point;
      MA_Slope2 = MA2;
         if (Sl>Slope2) MA_Slope2_Up=MA2;
         if (Sl<Slope2) MA_Slope2_Dn=MA2;

      if (MA_Slope1==MA_Slope1_Up && MA_Slope2==MA_Slope2_Up)
         MASO_Up[pos]=1;
      else
         if (MA_Slope1==MA_Slope1_Dn && MA_Slope2==MA_Slope2_Dn)
               MASO_Dn[pos]=1;
         else  MASO[pos]    =1;
      pos--;
   }
   return(0);
}